var doc = app.activeDocument;
var selectedTexts = [];
var newText = "";

// 選択されたテキストフレームを収集
for (var i = 0; i < doc.selection.length; i++) {
    var obj = doc.selection[i];
    if (obj.typename === "TextFrame") {
        selectedTexts.push(obj);
    }
}

if (selectedTexts.length === 0) {
    var msgNone = "テキストが選択されていません！";
    alert(msgNone);
} else if (selectedTexts.length < 2) {
    var msgFew = "2つ以上のテキストを選択してください！";
    alert(msgFew);
} else {
    // 上から順にソート（Y値が大きいほど上）
    selectedTexts.sort(function(a, b) { return b.top - a.top; });

    var reference = selectedTexts[0];
    var targetLayer = reference.layer;

    // テキストを改行で結合
    for (var j = 0; j < selectedTexts.length; j++) {
        newText += selectedTexts[j].contents;
        if (j !== selectedTexts.length - 1) {
            newText += "\n";
        }
    }

    // 新しいテキストフレームを作成
    var newTextFrame = targetLayer.textFrames.add();
    newTextFrame.contents = newText;
    newTextFrame.left = reference.left;
    newTextFrame.top = reference.top;

    newTextFrame.orientation = reference.orientation;

    var referenceAttr = reference.textRange.characterAttributes;
    var newAttr = newTextFrame.textRange.characterAttributes;

    newAttr.textFont = referenceAttr.textFont;
    newAttr.size = referenceAttr.size;
    newAttr.fillColor = referenceAttr.fillColor;
    newAttr.horizontalScale = referenceAttr.horizontalScale;
    newAttr.verticalScale = referenceAttr.verticalScale;
    newAttr.tracking = referenceAttr.tracking;
    newAttr.leading = referenceAttr.leading;
    newAttr.underline = referenceAttr.underline;
    newAttr.strikeThrough = referenceAttr.strikeThrough;

    // 元テキストを削除
    for (var k = 0; k < selectedTexts.length; k++) {
        selectedTexts[k].remove();
    }

    var msgDone = "行を結合しました。";
    alert(msgDone);
}
